using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using GrapeCity.ActiveReports.Document;
using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.Document.Section;

namespace CacheReport_CSharp
{
    /// <summary>
    /// Summary description for SectionReport1.
    /// </summary>
    public partial class SectionReport1 : GrapeCity.ActiveReports.SectionReport
    {

        public SectionReport1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
        }

        public SectionDocument Doc;
        int docs_count = 0;
        int counter = 0;

        private void SectionReport1_FetchData(object sender, FetchEventArgs eArgs)
        {
            counter++;
            if (counter <= 3000)
            {
                eArgs.EOF = false;
            }
            else
            {
                eArgs.EOF = true;
            }
        }

        private void detail_Format(object sender, EventArgs e)
        {
            textBox1.Text = "Record: " + counter.ToString();
        }

        private void SectionReport1_PageEnd(object sender, EventArgs e)
        {
            if (this.Document.Pages.Count > 52)
            {
                Doc = new SectionDocument();
                for (int j = 0; j < 50; j++)
                {
                    Doc.Pages.Add(this.Document.Pages[0].Clone() as Page);
                    this.Document.Pages.RemoveAt(0);
                }
                Doc.Save(System.Windows.Forms.Application.StartupPath + "\\doc_" + docs_count.ToString() + ".ddd");
                docs_count++;
                Doc.Pages.Clear();
                Doc.Dispose();
            }
        }

        private void SectionReport1_ReportEnd(object sender, EventArgs e)
        {
            SectionDocument DocTemp = new SectionDocument();
            Doc = new SectionDocument();
            for (int j = 0; j < docs_count; j++)
            {
                DocTemp.Load(System.Windows.Forms.Application.StartupPath + "\\doc_" + j.ToString() + ".ddd");
                Doc.Pages.AddRange(DocTemp.Pages.Clone() as PagesCollection);
                DocTemp.Pages.Clear();
                DocTemp.Dispose();
            }
            foreach (Page p in this.Document.Pages)
            {
                Doc.Pages.Add(p.Clone() as Page);
            }
            this.Document.Pages.Clear();
            this.Document.Pages.AddRange(Doc.Pages);
        }
    }
}
